#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x60NN1x1x1_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=60, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   #define Mb M
   #define Nb N
   const double *stM = A + (Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (60*(lda)), incAn = -(Mb);
   #define incBk 1
   const int incBm = -60, incBn = (ldb);
   #define incCm 1
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0;
   register double rB0;
   register double rC0_0;
   do /* N-loop */
   {
      ATL_pfl1R(pfA+0);
      ATL_pfl1R(pfA+16);
      ATL_pfl1R(pfA+32);
      pfA += lda;
      do /* M-loop */
      {
         rA0 = BetaAlpha;
         rC0_0 = *pC0;
         rC0_0 *= rA0;
         for (k=60; k; k--) /* easy loop to unroll */
         {
            rA0 = *pA0;
            rB0 = *pB0;
            rC0_0 += rA0 * rB0;
            pA0 += incAk;
            pB0 += incBk;
         }
         rB0 = alpha;
         rC0_0 *= rB0;
         *pC0 = rC0_0;
         pC0 += incCm;
         pA0 += incAm;
         pB0 += incBm;
      }
      while(pA0 != stM);
      pC0 += incCn;
      pA0 += incAn;
      pB0 += incBn;
   }
   while(pB0 != stN);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
static void ATL_dJIK0x0x60NN5x1x1_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=60, 
 * lda=0, ldb=0, ldc=0, mu=5, nu=1, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const int Mb = (M/5)*5;
   #define Nb N
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 5 - (60*(lda)), incAn = -(Mb);
   #define incBk 1
   const int incBm = -60, incBn = (ldb);
   #define incCm 5
   const int incCn = (ldc) - (Mb);
   double *pC0=C;
   const double *pA0=A;
   const double *pB0=B;
   register int k;
   register double rA0, rA1, rA2, rA3, rA4;
   register double rB0;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0;
   if (pA0 != stM)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         ATL_pfl1R(pfA+32);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC1_0 = pC0[1];
            rC1_0 *= rA0;
            rC2_0 = pC0[2];
            rC2_0 *= rA0;
            rC3_0 = pC0[3];
            rC3_0 *= rA0;
            rC4_0 = pC0[4];
            rC4_0 *= rA0;
            for (k=60; k; k--) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rA1 = pA0[1];
               rA2 = pA0[2];
               rA3 = pA0[3];
               rC0_0 += rA0 * rB0;
               rA4 = pA0[4];
               rC1_0 += rA1 * rB0;
               rC2_0 += rA2 * rB0;
               rC3_0 += rA3 * rB0;
               rC4_0 += rA4 * rB0;
               pA0 += incAk;
               pB0 += incBk;
            }
            rB0 = alpha;
            rC0_0 *= rB0;
            rC1_0 *= rB0;
            rC2_0 *= rB0;
            rC3_0 *= rB0;
            rC4_0 *= rB0;
            *pC0 = rC0_0;
            pC0[1] = rC1_0;
            pC0[2] = rC2_0;
            pC0[3] = rC3_0;
            pC0[4] = rC4_0;
            pC0 += incCm;
            pA0 += incAm;
            pB0 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pA0 += incAn;
         pB0 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=M-Mb)
      ATL_dJIK0x0x60NN1x1x1_aX_bX(k, N, 60, alpha, ca + (Mb), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
#ifndef ATL_RESTRICT
#if defined(__STDC_VERSION__) && (__STDC_VERSION__/100 >= 1999)
   #define ATL_RESTRICT restrict
#else
   #define ATL_RESTRICT
#endif
#endif
#include "atlas_prefetch.h"

static void ATL_dJIK0x0x60NN1x5x1_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=60, 
 * lda=0, ldb=0, ldc=0, mu=1, nu=5, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   #define Mb M
   const int Nb = (N/5)*5;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 1 - (60*(lda)), incAn = -(Mb);
   #define incBk 1
   const int incBm = -60, incBn = (((ldb) << 2)+ldb);
   #define incCm 1
   const int incCn = (((ldc) << 2)+ldc) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb);
   register int k;
   register double rA0;
   register double rB0, rB1, rB2, rB3, rB4;
   register double rC0_0, rC0_1, rC0_2, rC0_3, rC0_4;
   if (pB0 != stN)
   {
      do /* N-loop */
      {
         ATL_pfl1R(pfA+0);
         ATL_pfl1R(pfA+16);
         ATL_pfl1R(pfA+32);
         pfA += lda;
         do /* M-loop */
         {
            rA0 = BetaAlpha;
            rC0_0 = *pC0;
            rC0_0 *= rA0;
            rC0_1 = *pC1;
            rC0_1 *= rA0;
            rC0_2 = *pC2;
            rC0_2 *= rA0;
            rC0_3 = *pC3;
            rC0_3 *= rA0;
            rC0_4 = *pC4;
            rC0_4 *= rA0;
            for (k=60; k; k--) /* easy loop to unroll */
            {
               rA0 = *pA0;
               rB0 = *pB0;
               rB1 = *pB1;
               rB2 = *pB2;
               rB3 = *pB3;
               rC0_0 += rA0 * rB0;
               rB4 = *pB4;
               rC0_1 += rA0 * rB1;
               rC0_2 += rA0 * rB2;
               rC0_3 += rA0 * rB3;
               rC0_4 += rA0 * rB4;
               pA0 += incAk;
               pB0 += incBk;
               pB1 += incBk;
               pB2 += incBk;
               pB3 += incBk;
               pB4 += incBk;
            }
            rB0 = alpha;
            rC0_0 *= rB0;
            rC0_1 *= rB0;
            rC0_2 *= rB0;
            rC0_3 *= rB0;
            rC0_4 *= rB0;
            *pC0 = rC0_0;
            *pC1 = rC0_1;
            *pC2 = rC0_2;
            *pC3 = rC0_3;
            *pC4 = rC0_4;
            pC0 += incCm;
            pC1 += incCm;
            pC2 += incCm;
            pC3 += incCm;
            pC4 += incCm;
            pA0 += incAm;
            pB0 += incBm;
            pB1 += incBm;
            pB2 += incBm;
            pB3 += incBm;
            pB4 += incBm;
         }
         while(pA0 != stM);
         pC0 += incCn;
         pC1 += incCn;
         pC2 += incCn;
         pC3 += incCn;
         pC4 += incCn;
         pA0 += incAn;
         pB0 += incBn;
         pB1 += incBn;
         pB2 += incBn;
         pB3 += incBn;
         pB4 += incBn;
      }
      while(pB0 != stN);
   }
   if (k=N-Nb)
      ATL_dJIK0x0x60NN1x1x1_aX_bX(M, k, 60, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (Nb*ldc), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
void ATL_dJIK0x0x60NN0x0x0_aX_bX
   (const int M, const int N, const int K, const double alpha, const double * ATL_RESTRICT A, const int lda, const double * ATL_RESTRICT B, const int ldb, const double beta, double * ATL_RESTRICT C, const int ldc)
/*
 * matmul with TA=N, TB=N, MB=0, NB=0, KB=60, 
 * lda=0, ldb=0, ldc=0, mu=5, nu=5, ku=1, pf=1
 * Generated by ATLAS/tune/blas/gemm/emit_mm.c (3.10.2)
 */
{
   const int Mb = (M/5)*5;
   const int Nb = (N/5)*5;
   const double *ca=A, *cb=B;
   double *cc=C;
   const double *stM = A + (Mb);
   const double *stN = B + (ldb*Nb);
   const double *pfA = A + lda*M;
   const double BetaAlpha = beta / alpha;
   const int incAk = (lda);
   const int incAm = 5 - (60*(lda)), incAn = -(Mb);
   #define incBk 1
   const int incBm = -60, incBn = (((ldb) << 2)+ldb);
   #define incCm 5
   const int incCn = (((ldc) << 2)+ldc) - (Mb);
   double *pC0=C, *pC1=pC0+(ldc), *pC2=pC1+(ldc), *pC3=pC2+(ldc), *pC4=pC3+(ldc);
   const double *pA0=A;
   const double *pB0=B, *pB1=pB0+(ldb), *pB2=pB1+(ldb), *pB3=pB2+(ldb), *pB4=pB3+(ldb);
   register int k;
   register double rA0, rA1, rA2, rA3, rA4;
   register double rB0, rB1, rB2, rB3, rB4;
   register double rC0_0, rC1_0, rC2_0, rC3_0, rC4_0, rC0_1, rC1_1, rC2_1, rC3_1, rC4_1, rC0_2, rC1_2, rC2_2, rC3_2, rC4_2, rC0_3, rC1_3, rC2_3, rC3_3, rC4_3, rC0_4, rC1_4, rC2_4, rC3_4, rC4_4;
   if (pA0 != stM)
   {
      if (pB0 != stN)
      {
         do /* N-loop */
         {
            ATL_pfl1R(pfA+0);
            ATL_pfl1R(pfA+16);
            ATL_pfl1R(pfA+32);
            pfA += lda;
            do /* M-loop */
            {
               rA0 = BetaAlpha;
               rC0_0 = *pC0;
               rC0_0 *= rA0;
               rC1_0 = pC0[1];
               rC1_0 *= rA0;
               rC2_0 = pC0[2];
               rC2_0 *= rA0;
               rC3_0 = pC0[3];
               rC3_0 *= rA0;
               rC4_0 = pC0[4];
               rC4_0 *= rA0;
               rC0_1 = *pC1;
               rC0_1 *= rA0;
               rC1_1 = pC1[1];
               rC1_1 *= rA0;
               rC2_1 = pC1[2];
               rC2_1 *= rA0;
               rC3_1 = pC1[3];
               rC3_1 *= rA0;
               rC4_1 = pC1[4];
               rC4_1 *= rA0;
               rC0_2 = *pC2;
               rC0_2 *= rA0;
               rC1_2 = pC2[1];
               rC1_2 *= rA0;
               rC2_2 = pC2[2];
               rC2_2 *= rA0;
               rC3_2 = pC2[3];
               rC3_2 *= rA0;
               rC4_2 = pC2[4];
               rC4_2 *= rA0;
               rC0_3 = *pC3;
               rC0_3 *= rA0;
               rC1_3 = pC3[1];
               rC1_3 *= rA0;
               rC2_3 = pC3[2];
               rC2_3 *= rA0;
               rC3_3 = pC3[3];
               rC3_3 *= rA0;
               rC4_3 = pC3[4];
               rC4_3 *= rA0;
               rC0_4 = *pC4;
               rC0_4 *= rA0;
               rC1_4 = pC4[1];
               rC1_4 *= rA0;
               rC2_4 = pC4[2];
               rC2_4 *= rA0;
               rC3_4 = pC4[3];
               rC3_4 *= rA0;
               rC4_4 = pC4[4];
               rC4_4 *= rA0;
               for (k=60; k; k--) /* easy loop to unroll */
               {
                  rA0 = *pA0;
                  rB0 = *pB0;
                  rA1 = pA0[1];
                  rA2 = pA0[2];
                  rA3 = pA0[3];
                  rC0_0 += rA0 * rB0;
                  rA4 = pA0[4];
                  rB1 = *pB1;
                  rB2 = *pB2;
                  rB3 = *pB3;
                  rC1_0 += rA1 * rB0;
                  rB4 = *pB4;
                  rC2_0 += rA2 * rB0;
                  rC3_0 += rA3 * rB0;
                  rC4_0 += rA4 * rB0;
                  rC0_1 += rA0 * rB1;
                  rC1_1 += rA1 * rB1;
                  rC2_1 += rA2 * rB1;
                  rC3_1 += rA3 * rB1;
                  rC4_1 += rA4 * rB1;
                  rC0_2 += rA0 * rB2;
                  rC1_2 += rA1 * rB2;
                  rC2_2 += rA2 * rB2;
                  rC3_2 += rA3 * rB2;
                  rC4_2 += rA4 * rB2;
                  rC0_3 += rA0 * rB3;
                  rC1_3 += rA1 * rB3;
                  rC2_3 += rA2 * rB3;
                  rC3_3 += rA3 * rB3;
                  rC4_3 += rA4 * rB3;
                  rC0_4 += rA0 * rB4;
                  rC1_4 += rA1 * rB4;
                  rC2_4 += rA2 * rB4;
                  rC3_4 += rA3 * rB4;
                  rC4_4 += rA4 * rB4;
                  pA0 += incAk;
                  pB0 += incBk;
                  pB1 += incBk;
                  pB2 += incBk;
                  pB3 += incBk;
                  pB4 += incBk;
               }
               rB0 = alpha;
               rC0_0 *= rB0;
               rC0_1 *= rB0;
               rC0_2 *= rB0;
               rC0_3 *= rB0;
               rC0_4 *= rB0;
               rC1_0 *= rB0;
               rC1_1 *= rB0;
               rC1_2 *= rB0;
               rC1_3 *= rB0;
               rC1_4 *= rB0;
               rC2_0 *= rB0;
               rC2_1 *= rB0;
               rC2_2 *= rB0;
               rC2_3 *= rB0;
               rC2_4 *= rB0;
               rC3_0 *= rB0;
               rC3_1 *= rB0;
               rC3_2 *= rB0;
               rC3_3 *= rB0;
               rC3_4 *= rB0;
               rC4_0 *= rB0;
               rC4_1 *= rB0;
               rC4_2 *= rB0;
               rC4_3 *= rB0;
               rC4_4 *= rB0;
               *pC0 = rC0_0;
               pC0[1] = rC1_0;
               pC0[2] = rC2_0;
               pC0[3] = rC3_0;
               pC0[4] = rC4_0;
               *pC1 = rC0_1;
               pC1[1] = rC1_1;
               pC1[2] = rC2_1;
               pC1[3] = rC3_1;
               pC1[4] = rC4_1;
               *pC2 = rC0_2;
               pC2[1] = rC1_2;
               pC2[2] = rC2_2;
               pC2[3] = rC3_2;
               pC2[4] = rC4_2;
               *pC3 = rC0_3;
               pC3[1] = rC1_3;
               pC3[2] = rC2_3;
               pC3[3] = rC3_3;
               pC3[4] = rC4_3;
               *pC4 = rC0_4;
               pC4[1] = rC1_4;
               pC4[2] = rC2_4;
               pC4[3] = rC3_4;
               pC4[4] = rC4_4;
               pC0 += incCm;
               pC1 += incCm;
               pC2 += incCm;
               pC3 += incCm;
               pC4 += incCm;
               pA0 += incAm;
               pB0 += incBm;
               pB1 += incBm;
               pB2 += incBm;
               pB3 += incBm;
               pB4 += incBm;
            }
            while(pA0 != stM);
            pC0 += incCn;
            pC1 += incCn;
            pC2 += incCn;
            pC3 += incCn;
            pC4 += incCn;
            pA0 += incAn;
            pB0 += incBn;
            pB1 += incBn;
            pB2 += incBn;
            pB3 += incBn;
            pB4 += incBn;
         }
         while(pB0 != stN);
      }
   }
   if (k=N-Nb)
      ATL_dJIK0x0x60NN5x1x1_aX_bX(M, k, 60, alpha, ca, lda, cb + (Nb*ldb), ldb, beta, cc + (Nb*ldc), ldc);
   if (Nb && (k=M-Mb))
      ATL_dJIK0x0x60NN1x5x1_aX_bX(k, Nb, 60, alpha, ca + (Mb), lda, cb, ldb, beta, cc + (Mb), ldc);
}
#ifdef incAm
   #undef incAm
#endif
#ifdef incAn
   #undef incAn
#endif
#ifdef incAk
   #undef incAk
#endif
#ifdef incBm
   #undef incBm
#endif
#ifdef incBn
   #undef incBn
#endif
#ifdef incBk
   #undef incBk
#endif
#ifdef incCm
   #undef incCm
#endif
#ifdef incCn
   #undef incCn
#endif
#ifdef incCk
   #undef incCk
#endif
#ifdef Mb
   #undef Mb
#endif
#ifdef Nb
   #undef Nb
#endif
#ifdef Kb
   #undef Kb
#endif
